grammar Gram ;

parser parse :: Root_c { Gram ; }

function main 
IOVal<Integer> ::= args::[String] io_in::IO
{

  local attribute filename :: String = head(args) ;

  production attribute isF :: IOVal<Boolean> = isFile(filename, io_in) ;
   
  production attribute text :: IOVal<String> = readFile(filename, isF.io) ;

  local attribute result :: ParseResult<Root_c>;
  result = parse(text.iovalue, filename);

  local attribute r_cst :: Root_c;
  r_cst = result.parseTree;

  local attribute print_success :: IO;
  print_success = print(
                 "  PP   of the original Concrete : " ++ r_cst.pp   ++ "\n" ++
                 "  Show of the original Concrete : " ++ r_cst.show ++ "\n" ++
                 "\n**************** After Get: ****************\n" ++
                 "  Show of the Abstract          : " ++ r_cst.get_Root_c_Root.show ++ "\n" ++
                 "\n**************** After Put: ****************\n" ++
                 "  Show of the Concrete          : " ++ r_cst.get_Root_c_Root.put_Root_Root_c.show ++ "\n" ++
                 "  PP   of the Concrete          : " ++ r_cst.get_Root_c_Root.put_Root_Root_c.pp ++ "\n",
			           io_in );

  local attribute print_failure :: IO;  
  print_failure = print("Encountered a parse error:\n" ++ result.parseErrors ++ "\n", io_in);

  return ioval(if result.parseSuccess then print_success else print_failure, 0);
}

