grammar Gram;

synthesized attribute get_A :: A;

attribute get_A occurs on E;
attribute get_A occurs on T;
attribute get_A occurs on F;
aspect production p_Add
this::E ::= a::E Plus b::T
{
  this.get_A = get_A_1;
  local attribute get_A_1 :: A = case a, b of
                              | _, _ -> p_ADDa( a.get_A, b.get_A, link = linkE(this) )
                           end;
  local attribute get_A_0 :: A = error ("This transformation is not total for non terminal A");
}

aspect production p_Sub
this::E ::= a::E Minus b::T
{
  this.get_A = get_A_1;
  local attribute get_A_1 :: A = case a, b of
                              | _, _ -> p_SUBa( a.get_A, b.get_A, link = linkE(this) )
                           end;
  local attribute get_A_0 :: A = error ("This transformation is not total for non terminal A");
}

aspect production p_Et
this::E ::= a::T
{
  this.get_A = get_A_1;
  local attribute get_A_1 :: A = case a of
                              | _ -> a.get_A
                           end;
  local attribute get_A_0 :: A = error ("This transformation is not total for non terminal A");
}

aspect production p_Mul
this::T ::= a::T Ex b::F
{
  this.get_A = get_A_1;
  local attribute get_A_1 :: A = case a, b of
                              | _, _ -> p_MULa( a.get_A, b.get_A, link = linkT(this) )
                           end;
  local attribute get_A_0 :: A = error ("This transformation is not total for non terminal A");
}

aspect production p_Tf
this::T ::= a::F
{
  this.get_A = get_A_1;
  local attribute get_A_1 :: A = case a of
                              | _ -> a.get_A
                           end;
  local attribute get_A_0 :: A = error ("This transformation is not total for non terminal A");
}

aspect production p_Neg
this::F ::= Minus a::F
{
  this.get_A = get_A_1;
  local attribute get_A_1 :: A = case a of
                              | _ -> p_SUBa( p_VALUEa( terminal (Int_Lit, "0"), link = none()), a.get_A, link = linkF(this) )
                           end;
  local attribute get_A_0 :: A = error ("This transformation is not total for non terminal A");
}

aspect production p_Nest
this::F ::= LeftParen a::E RightParen
{
  this.get_A = get_A_1;
  local attribute get_A_1 :: A = case a of
                              | _ -> a.get_A
                           end;
  local attribute get_A_0 :: A = error ("This transformation is not total for non terminal A");
}

aspect production p_Value
this::F ::= a::Int_Lit
{
  this.get_A = get_A_1;
  local attribute get_A_1 :: A = p_VALUEa( a, link = linkF(this) );
  local attribute get_A_0 :: A = error ("This transformation is not total for non terminal A");
}

