grammar Gram;

synthesized attribute put_E :: E;
synthesized attribute put_T :: T;
synthesized attribute put_F :: F;

attribute put_E occurs on A;
attribute put_T occurs on A;
attribute put_F occurs on A;

aspect production p_ADDa
this::A ::= a::A b::A
{
  this.put_E = case this.link of
               | linkE(e) -> e
               | linkT(e) -> p_Et(e)
               | linkF(e) -> p_Et(p_Tf(e))
               | none() -> put_E_1
               end;
  local attribute put_E_1 :: E = case a, b of
                              | _, _ -> p_Add( a.put_E, terminal (Plus, "+"), b.put_T )
                           end;
  local attribute put_E_0 :: E = error ("This transformation is not total for non terminal E");

  this.put_T = case this.link of
               | linkE(e) -> p_Tf(p_Nest(terminal (LeftParen, "("), e, terminal (RightParen, ")")))
               | linkT(e) -> e
               | linkF(e) -> p_Tf(e)
               | none() -> put_T_1
               end;
  local attribute put_T_1 :: T = case a, b of
                              | _, _ -> p_Tf( p_Nest( terminal (LeftParen, "("), p_Add( a.put_E, terminal (Plus, "+"), b.put_T ), terminal (RightParen, ")") ) )
                           end;
  local attribute put_T_0 :: T = error ("This transformation is not total for non terminal T");

  this.put_F = case this.link of
               | linkE(e) -> p_Nest(terminal (LeftParen, "("), e, terminal (RightParen, ")"))
               | linkT(e) -> p_Nest(terminal (LeftParen, "("), p_Et(e), terminal (RightParen, ")"))
               | linkF(e) -> e
               | none() -> put_F_1
               end;
  local attribute put_F_1 :: F = case a, b of
                              | _, _ -> p_Nest( terminal (LeftParen, "("), p_Add( a.put_E, terminal (Plus, "+"), b.put_T ), terminal (RightParen, ")") )
                           end;
  local attribute put_F_0 :: F = error ("This transformation is not total for non terminal F");


}

aspect production p_SUBa
this::A ::= a::A b::A
{
  this.put_E = case this.link of
               | linkE(e) -> e
               | linkT(e) -> p_Et(e)
               | linkF(e) -> p_Et(p_Tf(e))
               | none() -> put_E_2
               end;
  local attribute put_E_2 :: E = case a, b of
                              | p_VALUEa( a ), _ -> if (a.lexeme == "0") then p_Et( p_Tf( p_Neg( terminal (Minus, "-"), b.put_F ) ) ) else put_E_1
                              | _, _ -> put_E_1
                           end;  local attribute put_E_1 :: E = case a, b of
                              | _, _ -> p_Sub( a.put_E, terminal (Minus, "-"), b.put_T )
                           end;
  local attribute put_E_0 :: E = error ("This transformation is not total for non terminal E");

  this.put_T = case this.link of
               | linkE(e) -> p_Tf(p_Nest(terminal (LeftParen, "("), e, terminal (RightParen, ")")))
               | linkT(e) -> e
               | linkF(e) -> p_Tf(e)
               | none() -> put_T_2
               end;
  local attribute put_T_2 :: T = case a, b of
                              | p_VALUEa( a ), _ -> if (a.lexeme == "0") then p_Tf( p_Neg( terminal (Minus, "-"), b.put_F ) ) else put_T_1
                              | _, _ -> put_T_1
                           end;  local attribute put_T_1 :: T = case a, b of
                              | _, _ -> p_Tf( p_Nest( terminal (LeftParen, "("), p_Sub( a.put_E, terminal (Minus, "-"), b.put_T ), terminal (RightParen, ")") ) )
                           end;
  local attribute put_T_0 :: T = error ("This transformation is not total for non terminal T");

  this.put_F = case this.link of
               | linkE(e) -> p_Nest(terminal (LeftParen, "("), e, terminal (RightParen, ")"))
               | linkT(e) -> p_Nest(terminal (LeftParen, "("), p_Et(e), terminal (RightParen, ")"))
               | linkF(e) -> e
               | none() -> put_F_2
               end;
  local attribute put_F_2 :: F = case a, b of
                              | p_VALUEa( a ), _ -> if (a.lexeme == "0") then p_Neg( terminal (Minus, "-"), b.put_F ) else put_F_1
                              | _, _ -> put_F_1
                           end;  local attribute put_F_1 :: F = case a, b of
                              | _, _ -> p_Nest( terminal (LeftParen, "("), p_Sub( a.put_E, terminal (Minus, "-"), b.put_T ), terminal (RightParen, ")") )
                           end;
  local attribute put_F_0 :: F = error ("This transformation is not total for non terminal F");


}

aspect production p_MULa
this::A ::= a::A b::A
{
  this.put_E = case this.link of
               | linkE(e) -> e
               | linkT(e) -> p_Et(e)
               | linkF(e) -> p_Et(p_Tf(e))
               | none() -> put_E_1
               end;
  local attribute put_E_1 :: E = case a, b of
                              | _, _ -> p_Et( p_Mul( a.put_T, terminal (Ex, "*"), b.put_F ) )
                           end;
  local attribute put_E_0 :: E = error ("This transformation is not total for non terminal E");

  this.put_T = case this.link of
               | linkE(e) -> p_Tf(p_Nest(terminal (LeftParen, "("), e, terminal (RightParen, ")")))
               | linkT(e) -> e
               | linkF(e) -> p_Tf(e)
               | none() -> put_T_1
               end;
  local attribute put_T_1 :: T = case a, b of
                              | _, _ -> p_Mul( a.put_T, terminal (Ex, "*"), b.put_F )
                           end;
  local attribute put_T_0 :: T = error ("This transformation is not total for non terminal T");

  this.put_F = case this.link of
               | linkE(e) -> p_Nest(terminal (LeftParen, "("), e, terminal (RightParen, ")"))
               | linkT(e) -> p_Nest(terminal (LeftParen, "("), p_Et(e), terminal (RightParen, ")"))
               | linkF(e) -> e
               | none() -> put_F_1
               end;
  local attribute put_F_1 :: F = case a, b of
                              | _, _ -> p_Nest( terminal (LeftParen, "("), p_Et( p_Mul( a.put_T, terminal (Ex, "*"), b.put_F ) ), terminal (RightParen, ")") )
                           end;
  local attribute put_F_0 :: F = error ("This transformation is not total for non terminal F");


}

aspect production p_VALUEa
this::A ::= a::Int_Lit
{
  this.put_E = case this.link of
               | linkE(e) -> e
               | linkT(e) -> p_Et(e)
               | linkF(e) -> p_Et(p_Tf(e))
               | none() -> put_E_1
               end;
  local attribute put_E_1 :: E = p_Et( p_Tf( p_Value( a ) ) );
  local attribute put_E_0 :: E = error ("This transformation is not total for non terminal E");

  this.put_T = case this.link of
               | linkE(e) -> p_Tf(p_Nest(terminal (LeftParen, "("), e, terminal (RightParen, ")")))
               | linkT(e) -> e
               | linkF(e) -> p_Tf(e)
               | none() -> put_T_1
               end;
  local attribute put_T_1 :: T = p_Tf( p_Value( a ) );
  local attribute put_T_0 :: T = error ("This transformation is not total for non terminal T");

  this.put_F = case this.link of
               | linkE(e) -> p_Nest(terminal (LeftParen, "("), e, terminal (RightParen, ")"))
               | linkT(e) -> p_Nest(terminal (LeftParen, "("), p_Et(e), terminal (RightParen, ")"))
               | linkF(e) -> e
               | none() -> put_F_1
               end;
  local attribute put_F_1 :: F = p_Value( a );
  local attribute put_F_0 :: F = error ("This transformation is not total for non terminal F");


}

