grammar Gram ;

parser the_parser :: Root_c { Gram ; }

function main 
IOVal<Integer> ::= args::[String] io_in::IO
{
  local attribute filename :: String = head(args) ;

  production attribute isF :: IOVal<Boolean> = isFile(filename, io_in) ;
   
  production attribute text :: IOVal<String> = readFile(filename, isF.io) ;

  local attribute result :: ParseResult<Root_c> ;
  result = the_parser(text.iovalue, filename) ;

  local attribute r_cst :: Root_c = result.parseTree;

  local attribute r_ast :: Root = r_cst.get_Root ;

  local attribute r_cst_put :: Root_c = r_ast.put_Root_c ;

  local attribute display :: String
    = "concrete pp: \n====================\n" ++ r_cst.pp ++ "\n\n" ++
      "concrete show: \n====================\n" ++ r_cst.show ++ "\n\n" ++
      "get: abstract pp: \n====================\n" ++ r_ast.pp ++ "\n\n" ++
      "get: abstract show: \n====================\n" ++ r_ast.show ++ "\n\n" ++

      "repair: abstract pp: \n====================\n" ++ r_ast.repair.pp ++ "\n\n" ++
      "repair: abstract show: \n====================\n" ++ r_ast.repair.show ++ "\n\n" ++

      "put: concrete pp: \n====================\n" ++ r_cst_put.pp ++ "\n\n" ++

      "Finished.\n\n" ;

  return if   ! isF.iovalue 
         then ioval( print( "File \"" ++ filename ++ "\" not found.\n\n", 
                            isF.io), 
                     1 )
         else
         if   ! result.parseSuccess 
         then ioval( print( "File had parse errors:\n" ++ 
                            result.parseErrors ++ "\n\n", text.io ) ,
                     2 )
         else ioval( print( display, text.io ) ,
                     0 ) ;
}

