grammar Gram;

synthesized attribute get_SL_V :: SL_V;

synthesized attribute get_DeclsList_V :: DeclsList_V;

synthesized attribute get_Type_V :: Type_V;

synthesized attribute get_ListStat_V :: ListStat_V;

synthesized attribute get_Stat_V :: Stat_V;

synthesized attribute get_Expr_V :: Expr_V;

synthesized attribute get_Txpr_V :: Txpr_V;

synthesized attribute get_Fxpr_V :: Fxpr_V;

attribute get_SL_V occurs on SL_S;
attribute get_DeclsList_V occurs on DeclsList_S;
attribute get_Type_V occurs on Type_S;
attribute get_ListStat_V occurs on ListStat_S;
attribute get_Stat_V occurs on Stat_S;
attribute get_Expr_V occurs on Expr_S;
attribute get_Txpr_V occurs on Txpr_S;
attribute get_Fxpr_V occurs on Fxpr_S;
aspect production p_Begin_S
this::SL_S ::= LeftSquareBrackets_S a::DeclsList_S VerticalBar_S b::ListStat_S RightSquareBrackets_S
{
  this.get_SL_V = get_SL_V_1;
  local attribute get_SL_V_1 :: SL_V = case a, b of
                              | _, _ -> p_Begin_V( terminal (LeftSquareBrackets_V, "["), a.get_DeclsList_V, terminal (VerticalBar_V, "|"), b.get_ListStat_V, terminal (RightSquareBrackets_V, "]"), link = linkSL_S(this) )
                           end;
  local attribute get_SL_V_0 :: SL_V = error ("This transformation is not total for non terminal SL_V");
}

aspect production p_OneDecl_S
this::DeclsList_S ::= a::Type_S b::String_Lit Semicollon_S
{
  this.get_DeclsList_V = get_DeclsList_V_1;
  local attribute get_DeclsList_V_1 :: DeclsList_V = case a of
                              | _ -> p_OneDecl_V( a.get_Type_V, b, terminal (Semicollon_V, ";"), link = linkDeclsList_S(this) )
                           end;
  local attribute get_DeclsList_V_0 :: DeclsList_V = error ("This transformation is not total for non terminal DeclsList_V");
}

aspect production p_TipoInt_S
this::Type_S ::= INT_S
{
  this.get_Type_V = get_Type_V_1;
  local attribute get_Type_V_1 :: Type_V = p_TipoInt_V( terminal (INT_V, "INT"), link = linkType_S(this) );
  local attribute get_Type_V_0 :: Type_V = error ("This transformation is not total for non terminal Type_V");
}

aspect production p_TipoString_S
this::Type_S ::= STR_S
{
  this.get_Type_V = get_Type_V_1;
  local attribute get_Type_V_1 :: Type_V = p_TipoString_V( terminal (STR_V, "STR"), link = linkType_S(this) );
  local attribute get_Type_V_0 :: Type_V = error ("This transformation is not total for non terminal Type_V");
}

aspect production p_VariousDecl_S
this::DeclsList_S ::= a::Type_S b::String_Lit Semicollon_S c::DeclsList_S
{
  this.get_DeclsList_V = get_DeclsList_V_1;
  local attribute get_DeclsList_V_1 :: DeclsList_V = case a, b of
                              | _, _ -> p_VariousDecl_V( a.get_Type_V, b, terminal (Semicollon_V, ";"), c.get_DeclsList_V, link = linkDeclsList_S(this) )
                           end;
  local attribute get_DeclsList_V_0 :: DeclsList_V = error ("This transformation is not total for non terminal DeclsList_V");
}

aspect production p_OneStat_S
this::ListStat_S ::= a::Stat_S
{
  this.get_ListStat_V = get_ListStat_V_1;
  local attribute get_ListStat_V_1 :: ListStat_V = case a of
                              | _ -> p_OneStat_V( a.get_Stat_V, link = linkListStat_S(this) )
                           end;
  local attribute get_ListStat_V_0 :: ListStat_V = error ("This transformation is not total for non terminal ListStat_V");
}

aspect production p_VariousStat_S
this::ListStat_S ::= a::Stat_S b::ListStat_S
{
  this.get_ListStat_V = get_ListStat_V_1;
  local attribute get_ListStat_V_1 :: ListStat_V = case a, b of
                              | _, _ -> p_VariousStat_V( a.get_Stat_V, b.get_ListStat_V, link = linkListStat_S(this) )
                           end;
  local attribute get_ListStat_V_0 :: ListStat_V = error ("This transformation is not total for non terminal ListStat_V");
}

aspect production p_Attrib_S
this::Stat_S ::= ATTRIB_S a::String_Lit Equal_S b::Expr_S Semicollon_S
{
  this.get_Stat_V = get_Stat_V_1;
  local attribute get_Stat_V_1 :: Stat_V = case a of
                              | _ -> p_Attrib_V( terminal (ATTRIB_V, "ATTRIB"), a, terminal (Equal_V, "="), b.get_Expr_V, terminal (Semicollon_V, ";"), link = linkStat_S(this) )
                           end;
  local attribute get_Stat_V_0 :: Stat_V = error ("This transformation is not total for non terminal Stat_V");
}

aspect production p_Sum_S
this::Expr_S ::= a::Expr_S Plus_S b::Txpr_S
{
  this.get_Expr_V = get_Expr_V_1;
  local attribute get_Expr_V_1 :: Expr_V = case a, b of
                              | _, _ -> p_Sum_V( a.get_Expr_V, terminal (Plus_V, "+"), b.get_Txpr_V, link = linkExpr_S(this) )
                           end;
  local attribute get_Expr_V_0 :: Expr_V = error ("This transformation is not total for non terminal Expr_V");
}

aspect production p_Sub_S
this::Expr_S ::= a::Expr_S Minus_S b::Txpr_S
{
  this.get_Expr_V = get_Expr_V_1;
  local attribute get_Expr_V_1 :: Expr_V = case a, b of
                              | _, _ -> p_Sub_V( a.get_Expr_V, terminal (Minus_V, "-"), b.get_Txpr_V, link = linkExpr_S(this) )
                           end;
  local attribute get_Expr_V_0 :: Expr_V = error ("This transformation is not total for non terminal Expr_V");
}

aspect production p_Et_S
this::Expr_S ::= a::Txpr_S
{
  this.get_Expr_V = get_Expr_V_1;
  local attribute get_Expr_V_1 :: Expr_V = case a of
                              | _ -> p_Et_V( a.get_Txpr_V, link = linkExpr_S(this) )
                           end;
  local attribute get_Expr_V_0 :: Expr_V = error ("This transformation is not total for non terminal Expr_V");
}

aspect production p_Mul_S
this::Txpr_S ::= a::Txpr_S Times_S b::Fxpr_S
{
  this.get_Txpr_V = get_Txpr_V_1;
  local attribute get_Txpr_V_1 :: Txpr_V = case a, b of
                              | _, _ -> p_Mul_V( a.get_Txpr_V, terminal (Times_V, "x"), b.get_Fxpr_V, link = linkTxpr_S(this) )
                           end;
  local attribute get_Txpr_V_0 :: Txpr_V = error ("This transformation is not total for non terminal Txpr_V");
}

aspect production p_Tf_S
this::Txpr_S ::= a::Fxpr_S
{
  this.get_Txpr_V = get_Txpr_V_1;
  local attribute get_Txpr_V_1 :: Txpr_V = case a of
                              | _ -> p_Tf_V( a.get_Fxpr_V, link = linkTxpr_S(this) )
                           end;
  local attribute get_Txpr_V_0 :: Txpr_V = error ("This transformation is not total for non terminal Txpr_V");
}

aspect production p_Neg_S
this::Fxpr_S ::= Minus_S a::Fxpr_S
{
  this.get_Fxpr_V = get_Fxpr_V_1;
  local attribute get_Fxpr_V_1 :: Fxpr_V = case a of
                              | _ -> p_Neg_V( terminal (Minus_V, "-"), a.get_Fxpr_V, link = linkFxpr_S(this) )
                           end;
  local attribute get_Fxpr_V_0 :: Fxpr_V = error ("This transformation is not total for non terminal Fxpr_V");
}

aspect production p_Nest_S
this::Fxpr_S ::= LeftParen_S a::Expr_S RightParen_S
{
  this.get_Fxpr_V = get_Fxpr_V_1;
  local attribute get_Fxpr_V_1 :: Fxpr_V = case a of
                              | _ -> p_Nest_V( terminal (LeftParen_V, "("), a.get_Expr_V, terminal (RightParen_V, ")"), link = linkFxpr_S(this) )
                           end;
  local attribute get_Fxpr_V_0 :: Fxpr_V = error ("This transformation is not total for non terminal Fxpr_V");
}

aspect production p_Const_S
this::Fxpr_S ::= a::Int_Lit
{
  this.get_Fxpr_V = get_Fxpr_V_1;
  local attribute get_Fxpr_V_1 :: Fxpr_V = p_Const_V( a, link = linkFxpr_S(this) );
  local attribute get_Fxpr_V_0 :: Fxpr_V = error ("This transformation is not total for non terminal Fxpr_V");
}

aspect production p_Variable_S
this::Fxpr_S ::= a::String_Lit
{
  this.get_Fxpr_V = get_Fxpr_V_1;
  local attribute get_Fxpr_V_1 :: Fxpr_V = p_Variable_V( a, link = linkFxpr_S(this) );
  local attribute get_Fxpr_V_0 :: Fxpr_V = error ("This transformation is not total for non terminal Fxpr_V");
}

aspect production p_Print_S
this::Stat_S ::= PRINT_S a::Expr_S Semicollon_S
{
  this.get_Stat_V = get_Stat_V_1;
  local attribute get_Stat_V_1 :: Stat_V = case a of
                              | _ -> p_Print_V( terminal (PRINT_V, "PRINT"), a.get_Expr_V, terminal (Semicollon_V, ";"), link = linkStat_S(this) )
                           end;
  local attribute get_Stat_V_0 :: Stat_V = error ("This transformation is not total for non terminal Stat_V");
}

aspect production p_While_S
this::Stat_S ::= WHILE_S a::Expr_S LeftBracket_S b::ListStat_S RightBracket_S
{
  this.get_Stat_V = get_Stat_V_1;
  local attribute get_Stat_V_1 :: Stat_V = case a, b of
                              | _, _ -> p_While_V( terminal (WHILE_V, "WHILE"), a.get_Expr_V, terminal (LeftBracket_V, "{"), b.get_ListStat_V, terminal (RightBracket_V, "}"), link = linkStat_S(this) )
                           end;
  local attribute get_Stat_V_0 :: Stat_V = error ("This transformation is not total for non terminal Stat_V");
}

aspect production p_RepeatUntil_S
this::Stat_S ::= REPEAT_S LeftBracket_S a::ListStat_S RightBracket_S UNTIL_S b::Expr_S
{
  this.get_Stat_V = get_Stat_V_1;
  local attribute get_Stat_V_1 :: Stat_V = case a, b of
                              | _, _ -> p_RepeatUntil_V( terminal (REPEAT_V, "REPEAT"), terminal (LeftBracket_V, "{"), a.get_ListStat_V, terminal (RightBracket_V, "}"), terminal (UNTIL_V, "UNTIL"), b.get_Expr_V, link = linkStat_S(this) )
                           end;
  local attribute get_Stat_V_0 :: Stat_V = error ("This transformation is not total for non terminal Stat_V");
}

