grammar Gram;

synthesized attribute to_ConcreteE :: ConcreteE;
synthesized attribute to_ConcreteT :: ConcreteT;
synthesized attribute to_ConcreteF :: ConcreteF;

nonterminal E with show, to_ConcreteE;
nonterminal T with show, to_ConcreteT;
nonterminal F with show, to_ConcreteF;

abstract production p_Add
this::E ::= a::E  c::T
{
  this.show = "Add(" ++ a.show ++ "," ++ c.show ++ ")";
  this.to_ConcreteE = p_ConcreteAdd( a.to_ConcreteE, terminal (Plus, "+"), c.to_ConcreteT );
}

abstract production p_Sub
this::E ::= a::E  c::T
{
  this.show = "Sub(" ++ a.show ++ "," ++ c.show ++ ")";
  this.to_ConcreteE = p_ConcreteSub( a.to_ConcreteE, terminal (Minus, "-"), c.to_ConcreteT );
}

abstract production p_Et
this::E ::= a::T
{
  this.show = "Et(" ++ a.show ++ ")";
  this.to_ConcreteE = p_ConcreteEt( a.to_ConcreteT );
}

abstract production p_Mul
this::T ::= a::T  c::F
{
  this.show = "Mul(" ++ a.show ++ "," ++ c.show ++ ")";
  this.to_ConcreteT = p_ConcreteMul( a.to_ConcreteT, terminal (Ex, "*"), c.to_ConcreteF );
}

abstract production p_Tf
this::T ::= a::F
{
  this.show = "Tf(" ++ a.show ++ ")";
  this.to_ConcreteT = p_ConcreteTf( a.to_ConcreteF );
}

abstract production p_Neg
this::F ::=  b::F
{
  this.show = "Neg(" ++ b.show ++ ")";
  this.to_ConcreteF = p_ConcreteNeg( terminal (Minus, "-"), b.to_ConcreteF );
}

abstract production p_Nest
this::F ::=  b::E 
{
  this.show = "Nest(" ++ b.show ++ ")";
  this.to_ConcreteF = p_ConcreteNest( terminal (LeftParen, "("), b.to_ConcreteE, terminal (RightParen, ")") );
}

abstract production p_Value
this::F ::= a::Int_NT
{
  this.show = "Value(" ++ a.getInfo ++ ")";
  this.to_ConcreteF = p_ConcreteValue( terminal (Int_Lit, a.getInfo) );
}

