module Terminals2Silver where

-- This function is just for initialization
-- of terminals and attributes that always appear
-- in both grammars

initialize = let init  = "grammar Gram;\n"
                 attrs = "synthesized attribute show :: String;"++ "\n" ++"synthesized attribute pp :: String;"
                 igns  = "ignore terminal WhiteSpace_t /[\\t\\n\\ ]+/ ;"
				 -- We manually had all the primitives supported in Bidi here,
				 -- to make code simpler. Prims that are declared but unused in
				 -- Silver are note a problem, and its easier than go through
				 -- both gramamrs to check the primitive types they use.
                 prims = "terminal Int_Lit /[0-9]+/;"++ "\n" ++"terminal String_Lit /[a-zA-Z][a-zA-Z0-9_]*/;"
             in  unlines [init,attrs,igns,prims,int_NT]

-- This is a production used so we don't have to deal with literals
-- in the transformations, only with their String form, but we still
-- retain their type information
int_NT = let s1  = "-- These NT used to be the Literal Terminals\n"
             s2  = "synthesized attribute getInfo :: String;"
             s3  = "nonterminal Int_NT with getInfo, pp, show;\n"
             s4  = "abstract production int_NT"
             s5  = "this::Int_NT ::= v::String"
             s6  = "{"
             s7  = "  this.show = \"int_NT (\" ++ v ++ \")\";"
             s8  = "  this.pp = v;"
             s9  = "  this.getInfo = v;"
             s10 = "}"
         in  unlines ["\n",s1,s2,s3,s4,s5,s6,s7,s8,s9,s10]

