grammar Gram ;

parser parse :: E { Gram ; }

function main 
IOVal<Integer> ::= largs::[String] io_in::IO
{

  local attribute args :: String;
  args = implode(" ", largs);

  local attribute result :: ParseResult<E>;
  result = parse(args, "<<args>>");

  local attribute r_cst :: E = result.parseTree;
  
  local attribute r_cst_a :: E_A = r_cst.toAbstractE_A ;

  local attribute r_ast :: A = r_cst_a.get_A ;

  local attribute print_success :: IO;
  print_success = print( "Command line expression        : " ++ args        ++ "\n\n" ++

				         "Show of the original Concrete_C  : " ++ r_cst.show  ++ "\n" ++
                 "PP   of the original Concrete_C  : " ++ r_cst.pp    ++ "\n\n" ++

                 "Show of the original Concrete_A  : " ++ r_cst.toAbstractE_A.show  ++ "\n" ++
                 "PP   of the original Concrete_A  : " ++ r_cst.toAbstractE_A.pp    ++ "\n\n" ++

						     "Show of the Abstract, after get: " ++ r_cst.toAbstractE_A.get_A.show  ++ "\n" ++
                 "PP   of the Abstract, after get: " ++ r_cst.toAbstractE_A.get_A.pp    ++ "\n\n" ++

						     "Show of the Concrete_A, after put: " ++ r_cst.toAbstractE_A.get_A.put_E_A.show ++ "\n"++
                 "PP   of the Concrete_A, after put: " ++ r_cst.toAbstractE_A.get_A.put_E_A.pp   ++ "\n\n"++

                 "Show of the Concrete_A, after put: " ++ r_cst.toAbstractE_A.get_A.put_E_A.toConcreteE.show ++ "\n"++
                 "PP   of the Concrete_A, after put: " ++ r_cst.toAbstractE_A.get_A.put_E_A.toConcreteE.pp   ++ "\n\n" ++

                 "Transformation, on Abstract:        " ++ r_ast.transform.show ++ "\n" ++
                 "Transformation, on Concrete (show): " ++ r_ast.transform.put_E_A.toConcreteE.show ++ "\n" ++
                 "Transformation, on Concrete (pp):   " ++ r_ast.transform.put_E_A.toConcreteE.pp ++ "\n\n" ,

			           io_in );

  local attribute print_failure :: IO;  
  print_failure = print("Encountered a parse error:\n" ++ result.parseErrors ++ "\n", io_in);

  return ioval(if result.parseSuccess then print_success else print_failure, 0);
}

