grammar Gram;

synthesized attribute put_E_A :: E_A;
synthesized attribute put_T_A :: T_A;
synthesized attribute put_F_A :: F_A;

attribute put_E_A occurs on A;
attribute put_T_A occurs on A;
attribute put_F_A occurs on A;


aspect production p_ADDa
this::A ::= a::A b::A
{
  this.put_E_A = p_Add_A( a.put_E_A, b.put_T_A );
  this.put_T_A = p_Tf_A( p_Nest_A( p_Add_A( a.put_E_A, b.put_T_A ) ) );
  this.put_F_A = p_Nest_A( p_Add_A( a.put_E_A, b.put_T_A ) );
}

aspect production p_SUBa
this::A ::= a::A b::A
{
  this.put_E_A = case this.link of
                 | linkE(e) -> e
                 | linkT(t) -> p_Et_A(t)
                 | linkF(f) -> p_Et_A(p_Tf_A(f))
                 | none() ->  put_E_A_no_link
                 end ;
  local attribute put_E_A_no_link :: E_A ;
  put_E_A_no_link = case a, b of
                    | p_VALUEa( int_NT("0") ), _ -> p_Et_A( p_Tf_A( p_Neg_A( b.put_F_A ) ) )
                    | _, _ -> p_Sub_A( a.put_E_A, b.put_T_A )
                    end ;

  this.put_T_A = case this.link of
                 | linkE(e) -> p_Tf_A ( p_Nest_A (e) )
                 | linkT(t) -> t
                 | linkF(f) -> p_Tf_A (f)
                 | none() ->   case a, b of
                               | p_VALUEa( int_NT("0") ), _ -> p_Tf_A( p_Neg_A( b.put_F_A ) )
                               | _, _ -> p_Tf_A( p_Nest_A( p_Sub_A( a.put_E_A, b.put_T_A ) ) )
                               end
                 end ;

  this.put_F_A = case this.link of
                 | linkE(e) -> p_Nest_A (e)
                 | linkT(t) -> p_Nest_A ( p_Et_A (t) )
                 | linkF(f) -> f
                 | none() ->   case a, b of
                               | p_VALUEa( int_NT("0") ), _ -> p_Neg_A( b.put_F_A )
                               | _, _ -> p_Nest_A( p_Sub_A( a.put_E_A, b.put_T_A ) )
                               end
                 end ;
}

aspect production p_MULa
this::A ::= a::A b::A
{
  this.put_E_A = p_Et_A( p_Mul_A( a.put_T_A, b.put_F_A ) );
  
  this.put_T_A = p_Mul_A( a.put_T_A, b.put_F_A );

  this.put_F_A = p_Nest_A(  p_Et_A( p_Mul_A( a.put_T_A, b.put_F_A ) ) ) ;
}

aspect production p_VALUEa
this::A ::= a::Int_NT
{
  this.put_E_A = p_Et_A( p_Tf_A( p_Value_A( a ) ) );

  this.put_T_A = p_Tf_A( p_Value_A( a ) );

  this.put_F_A = p_Value_A( a );

}


