grammar Gram;

synthesized attribute transform<a> :: a ;
attribute transform<A> occurs on A ;
attribute transform<Int_NT> occurs on Int_NT ;

{- (l + r) * b  -->   l*b + r*b
 -}
aspect production p_ADDa
this::A ::= a::A b::A
{
 this.transform = p_ADDa(a.transform, b.transform, link=none() ) ;
}

aspect production p_SUBa
this::A ::= a::A b::A
{
 this.transform = this ;
}

aspect production p_MULa
this::A ::= a::A b::A
{
 this.transform = case a of
                  | p_ADDa(l,r) -> p_ADDa ( p_MULa ( l.transform, b.transform, link=none() ),
                                            p_MULa ( r.transform, b.transform, link=none() ),
                                            link=none() )
                  | _ -> p_MULa ( a.transform, b.transform, link=none() )
                  end ;
}

aspect production p_VALUEa
this::A ::= a::Int_NT
{
 this.transform = p_VALUEa ( a.transform, link=none() ) ;
}

aspect production int_NT
this::Int_NT ::= v::String
{
 this.transform = int_NT(v) ;
}

