grammar Gram ;

attribute show occurs on Root_a, StmtA;

synthesized attribute put<a> :: a;
attribute put<Root_c> occurs on Root_a;
attribute put<StmtList> occurs on StmtA;

synthesized attribute put_Stmt<a> :: a;
attribute put_Stmt<Stmt> occurs on StmtA;

synthesized attribute regenerate<a> :: a;
attribute regenerate<Root_a> occurs on Root_a;
attribute regenerate<StmtA> occurs on StmtA;

synthesized attribute transf<a> :: a;
attribute transf<Root_a> occurs on Root_a;

nonterminal Root_a;
abstract production root_a
r::Root_a ::= ds::StmtA
{
  r.show = "root_a( " ++ ds.show ++ " )";
  r.put = root_c(ds.put);

  -- Information is lost in this transformation, but this is exterior to our bidis.
  local attribute new_left :: StmtA = constStmtA(StmExpr("x"),StmExpr("y"));
  r.transf = root_a( constStmtA(new_left, ds) );

}

nonterminal StmtA;
abstract production constStmtA
ds::StmtA ::= left::StmtA right::StmtA
{
  ds.show = "constStmtA( " ++ left.show ++ ", " ++ right.show ++ " )";
  ds.put  = consStmt(left.put_Stmt, right.put);

}

abstract production skipA
ds::StmtA ::=
{
  ds.show = "skipA()";
  ds.put = nilStmt();
}

abstract production StmExpr
ds::StmtA ::= s::String
{
  ds.show = "Expr( " ++ s ++ " )";
  ds.put_Stmt = oneStmt(terminal(Var, s), terminal(Semi_t,";"));
}

