grammar Gram ;

synthesized attribute show :: String
  occurs on Root_c, Stmt, StmtList;

synthesized attribute get<a> :: a ;
attribute get<Root_a> occurs on Root_c;
attribute get<StmtA> occurs on StmtList, Stmt;

nonterminal Root_c;
concrete production root_c
r::Root_c ::= ds::StmtList
{
  r.show = "root_c( " ++ ds.show ++ " )";
  r.get = root_a(ds.get);
}

nonterminal StmtList;
concrete production consStmt
ds::StmtList ::= st::Stmt stms::StmtList
{
  ds.show = "consStmt( " ++ st.show ++ ", " ++ stms.show ++ " )";
  ds.get = constStmtA(st.get, stms.get);
}

concrete production nilStmt
ds::StmtList ::=
{
  ds.show = "nilStmt()";
  ds.get = skipA();
}

nonterminal Stmt;
concrete production oneStmt
stm::Stmt ::= var::Var comma::Semi_t 
{
  stm.show = "oneStmt( " ++ var.lexeme ++ " )";
  stm.get = StmExpr(var.lexeme);
}

terminal Var /[a-zA-Z][a-zA-Z0-9]*/ submits to {Keywords} ;

lexer class Keywords ;

terminal EQUALS '=' lexer classes {Keywords} ;
terminal Semi_t ';' ;

ignore terminal WhiteSpace_t /[\t\n\ ]+/ ;

