grammar Gram ;

parser the_parser :: Root_c { Gram ; }

function main 
IOVal<Integer> ::= args::[String] io_in::IO
{
  local attribute filename :: String = head(args) ;

  production attribute isF :: IOVal<Boolean> = isFile(filename, io_in) ;
   
  production attribute text :: IOVal<String> = readFile(filename, isF.io) ;

  local attribute result :: ParseResult<Root_c> ;
  result = the_parser(text.iovalue, filename) ;

  local attribute r_cst :: Root_c = result.parseTree;

  local attribute display :: String
    = "concrete show: \n====================\n" ++ r_cst.show ++ "\n\n" ++
      "get: abstract show: \n====================\n" ++ r_cst.get.show ++ "\n\n" ++
      "get . transf: abstract show: \n====================\n" ++ r_cst.get.transf.show ++ "\n\n" ++
      "*** If we applied put right now the transformation would fail!***\n\n" ++
      "get : no transf abstract show: \n====================\n" ++ r_cst.get.show ++ "\n\n" ++
      "put : concrete show: \n====================\n" ++ r_cst.get.put.show ++ "\n\n" ++
      "Finished.\n\n" ;

  return if   ! isF.iovalue 
         then ioval( print( "File \"" ++ filename ++ "\" not found.\n\n", 
                            isF.io), 
                     1 )
         else
         if   ! result.parseSuccess 
         then ioval( print( "File had parse errors:\n" ++ 
                            result.parseErrors ++ "\n\n", text.io ) ,
                     2 )
         else ioval( print( display, text.io ) ,
                     0 ) ;
}

