grammar Gram;

synthesized attribute get_SL :: SL;
synthesized attribute get_DeclsList :: DeclsList;
synthesized attribute get_Type :: Type;
synthesized attribute get_ListStat :: ListStat;
synthesized attribute get_Stat :: Stat;
synthesized attribute get_Expr :: Expr;
synthesized attribute get_Txpr :: Txpr;
synthesized attribute get_Fxpr :: Fxpr;

attribute get_SL occurs on SL;
attribute get_DeclsList occurs on DeclsList;
attribute get_Type occurs on Type;
attribute get_ListStat occurs on ListStat;
attribute get_Stat occurs on Stat;
attribute get_Expr occurs on Expr;
attribute get_Txpr occurs on Txpr;
attribute get_Fxpr occurs on Fxpr;


aspect production p_Begin
this::SL ::= LeftSquareBrackets a::DeclsList VerticalBar b::ListStat RightSquareBrackets
{
  this.get_SL = get_SL_1;
  local attribute get_SL_1 :: SL = case a, b of
                              | _, _ -> p_Begin( terminal (LeftSquareBrackets, "["), a.get_DeclsList, terminal (VerticalBar, "|"), b.get_ListStat, terminal (RightSquareBrackets, "]") )
                           end;


  local attribute get_SL_0 :: SL = error ("This transformation is not total for non terminal SL");



}
aspect production p_OneDecl
this::DeclsList ::= a::Type i::String_Lit Semicollon
{
  this.get_DeclsList = get_DeclsList_1;
  local attribute get_DeclsList_1 :: DeclsList = case a of
                              | _ -> p_OneDecl( a.get_Type, i, terminal (Semicollon, ";") )
                           end;


  local attribute get_DeclsList_0 :: DeclsList = error ("This transformation is not total for non terminal DeclsList");



}
aspect production p_TipoInt
this::Type ::= INT
{
  this.get_Type = get_Type_1;
  local attribute get_Type_1 :: Type = p_TipoInt( terminal (INT, "INT") );

  local attribute get_Type_0 :: Type = error ("This transformation is not total for non terminal Type");



}
aspect production p_TipoString
this::Type ::= STR
{
  this.get_Type = get_Type_1;
  local attribute get_Type_1 :: Type = p_TipoString( terminal (STR, "STR") );

  local attribute get_Type_0 :: Type = error ("This transformation is not total for non terminal Type");



}
aspect production p_VariousDecl
this::DeclsList ::= a::Type i::String_Lit Semicollon b::DeclsList
{
  this.get_DeclsList = get_DeclsList_1;
  local attribute get_DeclsList_1 :: DeclsList = case a, i of
                              | _, _ -> p_VariousDecl( a.get_Type, i, terminal (Semicollon, ";"), b.get_DeclsList )
                           end;


  local attribute get_DeclsList_0 :: DeclsList = error ("This transformation is not total for non terminal DeclsList");



}
aspect production p_OneStat
this::ListStat ::= a::Stat
{
  this.get_ListStat = get_ListStat_1;
  local attribute get_ListStat_1 :: ListStat = case a of
                              | _ -> p_OneStat( a.get_Stat )
                           end;


  local attribute get_ListStat_0 :: ListStat = error ("This transformation is not total for non terminal ListStat");



}
aspect production p_VariousStat
this::ListStat ::= a::Stat b::ListStat
{
  this.get_ListStat = get_ListStat_1;
  local attribute get_ListStat_1 :: ListStat = case a, b of
                              | _, _ -> p_VariousStat( a.get_Stat, b.get_ListStat )
                           end;


  local attribute get_ListStat_0 :: ListStat = error ("This transformation is not total for non terminal ListStat");



}
aspect production p_Attrib
this::Stat ::= ATTRIB i::String_Lit Equal a::Expr Semicollon
{
  this.get_Stat = get_Stat_1;
  local attribute get_Stat_1 :: Stat = case i of
                              | _ -> p_Attrib( terminal (ATTRIB, "ATTRIB"), i, terminal (Equal, "="), a.get_Expr, terminal (Semicollon, ";") )
                           end;


  local attribute get_Stat_0 :: Stat = error ("This transformation is not total for non terminal Stat");



}
aspect production p_Sum
this::Expr ::= a::Expr Plus b::Txpr
{
  this.get_Expr = get_Expr_1;
  local attribute get_Expr_1 :: Expr = case a, b of
                              | _, _ -> p_Sum( a.get_Expr, terminal (Plus, "+"), b.get_Txpr )
                           end;


  local attribute get_Expr_0 :: Expr = error ("This transformation is not total for non terminal Expr");



}
aspect production p_Sub
this::Expr ::= a::Expr Minus b::Txpr
{
  this.get_Expr = get_Expr_1;
  local attribute get_Expr_1 :: Expr = case a, b of
                              | _, _ -> p_Sub( a.get_Expr, terminal (Minus, "-"), b.get_Txpr )
                           end;


  local attribute get_Expr_0 :: Expr = error ("This transformation is not total for non terminal Expr");



}
aspect production p_Et
this::Expr ::= a::Txpr
{
  this.get_Expr = get_Expr_1;
  local attribute get_Expr_1 :: Expr = case a of
                              | _ -> p_Et( a.get_Txpr )
                           end;


  local attribute get_Expr_0 :: Expr = error ("This transformation is not total for non terminal Expr");



}
aspect production p_Mul
this::Txpr ::= a::Txpr Times b::Fxpr
{
  this.get_Txpr = get_Txpr_1;
  local attribute get_Txpr_1 :: Txpr = case a, b of
                              | _, _ -> p_Mul( a.get_Txpr, terminal (Times, "x"), b.get_Fxpr )
                           end;


  local attribute get_Txpr_0 :: Txpr = error ("This transformation is not total for non terminal Txpr");



}
aspect production p_Tf
this::Txpr ::= a::Fxpr
{
  this.get_Txpr = get_Txpr_1;
  local attribute get_Txpr_1 :: Txpr = case a of
                              | _ -> p_Tf( a.get_Fxpr )
                           end;


  local attribute get_Txpr_0 :: Txpr = error ("This transformation is not total for non terminal Txpr");



}
aspect production p_Neg
this::Fxpr ::= Minus a::Fxpr
{
  this.get_Fxpr = get_Fxpr_1;
  local attribute get_Fxpr_1 :: Fxpr = case a of
                              | _ -> p_Neg( terminal (Minus, "-"), a.get_Fxpr )
                           end;


  local attribute get_Fxpr_0 :: Fxpr = error ("This transformation is not total for non terminal Fxpr");



}
aspect production p_Nest
this::Fxpr ::= LeftParen a::Expr RightParen
{
  this.get_Fxpr = get_Fxpr_1;
  local attribute get_Fxpr_1 :: Fxpr = case a of
                              | _ -> p_Nest( terminal (LeftParen, "("), a.get_Expr, terminal (RightParen, ")") )
                           end;


  local attribute get_Fxpr_0 :: Fxpr = error ("This transformation is not total for non terminal Fxpr");



}
aspect production p_Const
this::Fxpr ::= a::Int_Lit
{
  this.get_Fxpr = get_Fxpr_1;
  local attribute get_Fxpr_1 :: Fxpr = p_Const( a );

  local attribute get_Fxpr_0 :: Fxpr = error ("This transformation is not total for non terminal Fxpr");



}
aspect production p_Variable
this::Fxpr ::= a::String_Lit
{
  this.get_Fxpr = get_Fxpr_1;
  local attribute get_Fxpr_1 :: Fxpr = p_Variable( a );

  local attribute get_Fxpr_0 :: Fxpr = error ("This transformation is not total for non terminal Fxpr");



}
aspect production p_Print
this::Stat ::= PRINT a::Expr Semicollon
{
  this.get_Stat = get_Stat_1;
  local attribute get_Stat_1 :: Stat = case a of
                              | _ -> p_Print( terminal (PRINT, "PRINT"), a.get_Expr, terminal (Semicollon, ";") )
                           end;


  local attribute get_Stat_0 :: Stat = error ("This transformation is not total for non terminal Stat");



}
aspect production p_While
this::Stat ::= WHILE a::Expr LeftBracket b::ListStat RightBracket
{
  this.get_Stat = get_Stat_1;
  local attribute get_Stat_1 :: Stat = case a, b of
                              | _, _ -> p_While( terminal (WHILE, "WHILE"), a.get_Expr, terminal (LeftBracket, "{"), b.get_ListStat, terminal (RightBracket, "}") )
                           end;


  local attribute get_Stat_0 :: Stat = error ("This transformation is not total for non terminal Stat");



}
aspect production p_RepeatUntil
this::Stat ::= REPEAT LeftBracket a::ListStat RightBracket UNTIL b::Expr
{
  this.get_Stat = get_Stat_1;
  local attribute get_Stat_1 :: Stat = case a, b of
                              | _, _ -> p_While( terminal (WHILE, "WHILE"), b.get_Expr, terminal (LeftBracket, "{"), a.get_ListStat, terminal (RightBracket, "}") )
                           end;


  local attribute get_Stat_0 :: Stat = error ("This transformation is not total for non terminal Stat");



}

