grammar Gram;

synthesized attribute put_Fxpr :: Fxpr;
synthesized attribute put_Txpr :: Txpr;
synthesized attribute put_Expr :: Expr;
synthesized attribute put_Stat :: Stat;
synthesized attribute put_ListStat :: ListStat;
synthesized attribute put_Type :: Type;
synthesized attribute put_DeclsList :: DeclsList;
synthesized attribute put_SL :: SL;

attribute put_Fxpr occurs on Fxpr;
attribute put_Txpr occurs on Txpr;
attribute put_Expr occurs on Expr;
attribute put_Stat occurs on Stat;
attribute put_ListStat occurs on ListStat;
attribute put_Type occurs on Type;
attribute put_DeclsList occurs on DeclsList;
attribute put_SL occurs on SL;


aspect production p_Begin
this::SL ::= LeftSquareBrackets a::DeclsList VerticalBar b::ListStat RightSquareBrackets
{
  this.put_SL = put_SL_1;
  local attribute put_SL_1 :: SL = case a, b of
                              | _, _ -> p_Begin( terminal (LeftSquareBrackets, "["), a.put_DeclsList, terminal (VerticalBar, "|"), b.put_ListStat, terminal (RightSquareBrackets, "]") )
                           end;


  local attribute put_SL_0 :: SL = error ("This transformation is not total for non terminal SL");



}
aspect production p_OneDecl
this::DeclsList ::= a::Type i::String_Lit Semicollon
{
  this.put_DeclsList = put_DeclsList_1;
  local attribute put_DeclsList_1 :: DeclsList = case a of
                              | _ -> p_OneDecl( a.put_Type, i, terminal (Semicollon, ";") )
                           end;


  local attribute put_DeclsList_0 :: DeclsList = error ("This transformation is not total for non terminal DeclsList");



}
aspect production p_TipoInt
this::Type ::= INT
{
  this.put_Type = put_Type_1;
  local attribute put_Type_1 :: Type = p_TipoInt( terminal (INT, "INT") );

  local attribute put_Type_0 :: Type = error ("This transformation is not total for non terminal Type");



}
aspect production p_TipoString
this::Type ::= STR
{
  this.put_Type = put_Type_1;
  local attribute put_Type_1 :: Type = p_TipoString( terminal (STR, "STR") );

  local attribute put_Type_0 :: Type = error ("This transformation is not total for non terminal Type");



}
aspect production p_VariousDecl
this::DeclsList ::= a::Type i::String_Lit Semicollon b::DeclsList
{
  this.put_DeclsList = put_DeclsList_1;
  local attribute put_DeclsList_1 :: DeclsList = case a, i of
                              | _, _ -> p_VariousDecl( a.put_Type, i, terminal (Semicollon, ";"), b.put_DeclsList )
                           end;


  local attribute put_DeclsList_0 :: DeclsList = error ("This transformation is not total for non terminal DeclsList");



}
aspect production p_OneStat
this::ListStat ::= a::Stat
{
  this.put_ListStat = put_ListStat_1;
  local attribute put_ListStat_1 :: ListStat = case a of
                              | _ -> p_OneStat( a.put_Stat )
                           end;


  local attribute put_ListStat_0 :: ListStat = error ("This transformation is not total for non terminal ListStat");



}
aspect production p_VariousStat
this::ListStat ::= a::Stat b::ListStat
{
  this.put_ListStat = put_ListStat_1;
  local attribute put_ListStat_1 :: ListStat = case a, b of
                              | _, _ -> p_VariousStat( a.put_Stat, b.put_ListStat )
                           end;


  local attribute put_ListStat_0 :: ListStat = error ("This transformation is not total for non terminal ListStat");



}
aspect production p_Attrib
this::Stat ::= ATTRIB i::String_Lit Equal a::Expr Semicollon
{
  this.put_Stat = put_Stat_1;
  local attribute put_Stat_1 :: Stat = case i of
                              | _ -> p_Attrib( terminal (ATTRIB, "ATTRIB"), i, terminal (Equal, "="), a.put_Expr, terminal (Semicollon, ";") )
                           end;


  local attribute put_Stat_0 :: Stat = error ("This transformation is not total for non terminal Stat");



}
aspect production p_Sum
this::Expr ::= a::Expr Plus b::Txpr
{
  this.put_Expr = put_Expr_1;
  local attribute put_Expr_1 :: Expr = case a, b of
                              | _, _ -> p_Sum( a.put_Expr, terminal (Plus, "+"), b.put_Txpr )
                           end;


  local attribute put_Expr_0 :: Expr = error ("This transformation is not total for non terminal Expr");



}
aspect production p_Sub
this::Expr ::= a::Expr Minus b::Txpr
{
  this.put_Expr = put_Expr_1;
  local attribute put_Expr_1 :: Expr = case a, b of
                              | _, _ -> p_Sub( a.put_Expr, terminal (Minus, "-"), b.put_Txpr )
                           end;


  local attribute put_Expr_0 :: Expr = error ("This transformation is not total for non terminal Expr");



}
aspect production p_Et
this::Expr ::= a::Txpr
{
  this.put_Expr = put_Expr_1;
  local attribute put_Expr_1 :: Expr = case a of
                              | _ -> p_Et( a.put_Txpr )
                           end;


  local attribute put_Expr_0 :: Expr = error ("This transformation is not total for non terminal Expr");



}
aspect production p_Mul
this::Txpr ::= a::Txpr Times b::Fxpr
{
  this.put_Txpr = put_Txpr_1;
  local attribute put_Txpr_1 :: Txpr = case a, b of
                              | _, _ -> p_Mul( a.put_Txpr, terminal (Times, "x"), b.put_Fxpr )
                           end;


  local attribute put_Txpr_0 :: Txpr = error ("This transformation is not total for non terminal Txpr");



}
aspect production p_Tf
this::Txpr ::= a::Fxpr
{
  this.put_Txpr = put_Txpr_1;
  local attribute put_Txpr_1 :: Txpr = case a of
                              | _ -> p_Tf( a.put_Fxpr )
                           end;


  local attribute put_Txpr_0 :: Txpr = error ("This transformation is not total for non terminal Txpr");



}
aspect production p_Neg
this::Fxpr ::= Minus a::Fxpr
{
  this.put_Fxpr = put_Fxpr_1;
  local attribute put_Fxpr_1 :: Fxpr = case a of
                              | _ -> p_Neg( terminal (Minus, "-"), a.put_Fxpr )
                           end;


  local attribute put_Fxpr_0 :: Fxpr = error ("This transformation is not total for non terminal Fxpr");



}
aspect production p_Nest
this::Fxpr ::= LeftParen a::Expr RightParen
{
  this.put_Fxpr = put_Fxpr_1;
  local attribute put_Fxpr_1 :: Fxpr = case a of
                              | _ -> p_Nest( terminal (LeftParen, "("), a.put_Expr, terminal (RightParen, ")") )
                           end;


  local attribute put_Fxpr_0 :: Fxpr = error ("This transformation is not total for non terminal Fxpr");



}
aspect production p_Const
this::Fxpr ::= a::Int_Lit
{
  this.put_Fxpr = put_Fxpr_1;
  local attribute put_Fxpr_1 :: Fxpr = p_Const( a );

  local attribute put_Fxpr_0 :: Fxpr = error ("This transformation is not total for non terminal Fxpr");



}
aspect production p_Variable
this::Fxpr ::= a::String_Lit
{
  this.put_Fxpr = put_Fxpr_1;
  local attribute put_Fxpr_1 :: Fxpr = p_Variable( a );

  local attribute put_Fxpr_0 :: Fxpr = error ("This transformation is not total for non terminal Fxpr");



}
aspect production p_Print
this::Stat ::= PRINT a::Expr Semicollon
{
  this.put_Stat = put_Stat_1;
  local attribute put_Stat_1 :: Stat = case a of
                              | _ -> p_Print( terminal (PRINT, "PRINT"), a.put_Expr, terminal (Semicollon, ";") )
                           end;


  local attribute put_Stat_0 :: Stat = error ("This transformation is not total for non terminal Stat");



}
aspect production p_While
this::Stat ::= WHILE b::Expr LeftBracket a::ListStat RightBracket
{
  this.put_Stat = put_Stat_2;
  local attribute put_Stat_2 :: Stat = case b, a of
                              | _, _ -> p_While( terminal (WHILE, "WHILE"), a.put_Expr, terminal (LeftBracket, "{"), b.put_ListStat, terminal (RightBracket, "}") )
                           end;

  local attribute put_Stat_1 :: Stat = case b, a of
                              | _, _ -> p_RepeatUntil( terminal (REPEAT, "REPEAT"), terminal (LeftBracket, "{"), a.put_ListStat, terminal (RightBracket, "}"), terminal (UNTIL, "UNTIL"), b.put_Expr )
                           end;


  local attribute put_Stat_0 :: Stat = error ("This transformation is not total for non terminal Stat");



}

