grammar Gram;


nonterminal E with pp, show;
nonterminal T with pp, show;
nonterminal F with pp, show;


terminal LeftParen '(';
terminal RightParen ')';
terminal Plus '+';
terminal Minus '-';
terminal Ex '*';


concrete production p_Add
this::E ::= a::E b::Plus c::T
{
  this.show = "Add(" ++ a.show ++ "," ++ " + " ++ "," ++ c.show ++ ")";
}

concrete production p_Sub
this::E ::= a::E b::Minus c::T
{
  this.show = "Sub(" ++ a.show ++ "," ++ " - " ++ "," ++ c.show ++ ")";
}

concrete production p_Et
this::E ::= a::T
{
  this.show = "Et(" ++ a.show ++ ")";
}

concrete production p_Mul
this::T ::= a::T b::Ex c::F
{
  this.show = "Mul(" ++ a.show ++ "," ++ " * " ++ "," ++ c.show ++ ")";
}

concrete production p_Tf
this::T ::= a::F
{
  this.show = "Tf(" ++ a.show ++ ")";
}

concrete production p_Neg
this::F ::= a::Minus b::F
{
  this.show = "Neg(" ++ " - " ++ "," ++ b.show ++ ")";
}

concrete production p_Nest
this::F ::= a::LeftParen b::E c::RightParen
{
  this.show = "Nest(" ++ " ( " ++ "," ++ b.show ++ "," ++ " ) " ++ ")";
}

concrete production p_Value
this::F ::= a::Int_Lit
{
  this.show = "Value(" ++ a.lexeme ++ ")";
}


