grammar Gram;

synthesized attribute transformSL :: SL;

synthesized attribute transformDeclsList :: DeclsList;

synthesized attribute transformType :: Type;

synthesized attribute transformListStat :: ListStat;

synthesized attribute transformStat :: Stat;

synthesized attribute transformExpr :: Expr;

synthesized attribute transformTxpr :: Txpr;

synthesized attribute transformFxpr :: Fxpr;


attribute transformSL occurs on SL;

attribute transformDeclsList occurs on DeclsList;

attribute transformType occurs on Type;

attribute transformListStat occurs on ListStat;

attribute transformStat occurs on Stat;

attribute transformExpr occurs on Expr;

attribute transformTxpr occurs on Txpr;

attribute transformFxpr occurs on Fxpr;



aspect production p_Begin
this::SL ::= LeftSquareBrackets a::DeclsList VerticalBar b::ListStat RightSquareBrackets
{
  this.transformSL = transformSL_1;
  local attribute transformSL_1 :: SL = case a, b of
                              | _, _ -> p_Begin( terminal (LeftSquareBrackets, "["), a.transformDeclsList, terminal (VerticalBar, "|"), b.transformListStat, terminal (RightSquareBrackets, "]") )
                           end;


  local attribute transformSL_0 :: SL = error ("This transformation is not total for non terminal SL");



}
aspect production p_OneDecl
this::DeclsList ::= a::Type i::String_Lit Semicollon
{
  this.transformDeclsList = transformDeclsList_1;
  local attribute transformDeclsList_1 :: DeclsList = case a of
                              | _ -> p_OneDecl( a.transformType, i, terminal (Semicollon, ";") )
                           end;


  local attribute transformDeclsList_0 :: DeclsList = error ("This transformation is not total for non terminal DeclsList");



}
aspect production p_TipoInt
this::Type ::= INT
{
  this.transformType = transformType_1;
  local attribute transformType_1 :: Type = p_TipoInt( terminal (INT, "INT") );

  local attribute transformType_0 :: Type = error ("This transformation is not total for non terminal Type");



}
aspect production p_TipoString
this::Type ::= STR
{
  this.transformType = transformType_1;
  local attribute transformType_1 :: Type = p_TipoString( terminal (STR, "STR") );

  local attribute transformType_0 :: Type = error ("This transformation is not total for non terminal Type");



}
aspect production p_VariousDecl
this::DeclsList ::= a::Type i::String_Lit Semicollon b::DeclsList
{
  this.transformDeclsList = transformDeclsList_1;
  local attribute transformDeclsList_1 :: DeclsList = case a, b of
                              | _, _ -> p_VariousDecl( a.transformType, i, terminal (Semicollon, ";"), b.transformDeclsList )
                           end;


  local attribute transformDeclsList_0 :: DeclsList = error ("This transformation is not total for non terminal DeclsList");



}
aspect production p_OneStat
this::ListStat ::= a::Stat
{
  this.transformListStat = transformListStat_1;
  local attribute transformListStat_1 :: ListStat = case a of
                              | _ -> p_OneStat( a.transformStat )
                           end;


  local attribute transformListStat_0 :: ListStat = error ("This transformation is not total for non terminal ListStat");



}
aspect production p_VariousStat
this::ListStat ::= a::Stat b::ListStat
{
  this.transformListStat = transformListStat_1;
  local attribute transformListStat_1 :: ListStat = case a, b of
                              | _, _ -> p_VariousStat( a.transformStat, b.transformListStat )
                           end;


  local attribute transformListStat_0 :: ListStat = error ("This transformation is not total for non terminal ListStat");



}
aspect production p_Sum
this::Expr ::= a::Expr Plus b::Txpr
{
  this.transformExpr = transformExpr_1;
  local attribute transformExpr_1 :: Expr = case a, b of
                              | _, _ -> p_Sum( a.transformExpr, terminal (Plus, "+"), b.transformTxpr )
                           end;


  local attribute transformExpr_0 :: Expr = error ("This transformation is not total for non terminal Expr");



}
aspect production p_Sub
this::Expr ::= a::Expr Minus b::Txpr
{
  this.transformExpr = transformExpr_1;
  local attribute transformExpr_1 :: Expr = case a, b of
                              | _, _ -> p_Sub( a.transformExpr, terminal (Minus, "-"), b.transformTxpr )
                           end;


  local attribute transformExpr_0 :: Expr = error ("This transformation is not total for non terminal Expr");



}
aspect production p_Et
this::Expr ::= a::Txpr
{
  this.transformExpr = transformExpr_1;
  local attribute transformExpr_1 :: Expr = case a of
                              | _ -> p_Et( a.transformTxpr )
                           end;


  local attribute transformExpr_0 :: Expr = error ("This transformation is not total for non terminal Expr");



}
aspect production p_Mul
this::Txpr ::= a::Txpr Times b::Fxpr
{
  this.transformTxpr = transformTxpr_1;
  local attribute transformTxpr_1 :: Txpr = case a, b of
                              | _, _ -> p_Mul( a.transformTxpr, terminal (Times, "x"), b.transformFxpr )
                           end;


  local attribute transformTxpr_0 :: Txpr = error ("This transformation is not total for non terminal Txpr");



}
aspect production p_Tf
this::Txpr ::= a::Fxpr
{
  this.transformTxpr = transformTxpr_1;
  local attribute transformTxpr_1 :: Txpr = case a of
                              | _ -> p_Tf( a.transformFxpr )
                           end;


  local attribute transformTxpr_0 :: Txpr = error ("This transformation is not total for non terminal Txpr");



}
aspect production p_Neg
this::Fxpr ::= Minus a::Fxpr
{
  this.transformFxpr = transformFxpr_1;
  local attribute transformFxpr_1 :: Fxpr = case a of
                              | _ -> p_Neg( terminal (Minus, "-"), a.transformFxpr )
                           end;


  local attribute transformFxpr_0 :: Fxpr = error ("This transformation is not total for non terminal Fxpr");



}
aspect production p_Nest
this::Fxpr ::= LeftParen a::Expr RightParen
{
  this.transformFxpr = transformFxpr_1;
  local attribute transformFxpr_1 :: Fxpr = case a of
                              | _ -> p_Nest( terminal (LeftParen, "("), a.transformExpr, terminal (RightParen, ")") )
                           end;


  local attribute transformFxpr_0 :: Fxpr = error ("This transformation is not total for non terminal Fxpr");



}
aspect production p_Const
this::Fxpr ::= a::Int_Lit
{
  this.transformFxpr = transformFxpr_1;
  local attribute transformFxpr_1 :: Fxpr = p_Const( a );

  local attribute transformFxpr_0 :: Fxpr = error ("This transformation is not total for non terminal Fxpr");



}
aspect production p_Variable
this::Fxpr ::= a::String_Lit
{
  this.transformFxpr = transformFxpr_1;
  local attribute transformFxpr_1 :: Fxpr = p_Variable( a );

  local attribute transformFxpr_0 :: Fxpr = error ("This transformation is not total for non terminal Fxpr");



}
aspect production p_IfElse
this::Stat ::= IF LeftParen a::Expr RightParen THEN LeftBracket b::ListStat RightBracket ELSE LeftBracket c::ListStat RightBracket
{
  this.transformStat = transformStat_1;
  local attribute transformStat_1 :: Stat = case a, b, c of
                              | _, _, _ -> p_IfElse( terminal (IF, "IF"), terminal (LeftParen, "("), a.transformExpr, terminal (RightParen, ")"), terminal (THEN, "THEN"), terminal (LeftBracket, "{"), b.transformListStat, terminal (RightBracket, "}"), terminal (ELSE, "ELSE"), terminal (LeftBracket, "{"), c.transformListStat, terminal (RightBracket, "}") )
                           end;


  local attribute transformStat_0 :: Stat = error ("This transformation is not total for non terminal Stat");



}
aspect production p_Print
this::Stat ::= PRINT a::Expr Semicollon
{
  this.transformStat = transformStat_1;
  local attribute transformStat_1 :: Stat = case a of
                              | _ -> p_Print( terminal (PRINT, "PRINT"), a.transformExpr, terminal (Semicollon, ";") )
                           end;


  local attribute transformStat_0 :: Stat = error ("This transformation is not total for non terminal Stat");



}
aspect production p_While
this::Stat ::= WHILE LeftParen a::Expr RightParen LeftBracket b::ListStat RightBracket
{
  this.transformStat = transformStat_1;
  local attribute transformStat_1 :: Stat = case a, b of
                              | _, _ -> p_While( terminal (WHILE, "WHILE"), terminal (LeftParen, "("), a.transformExpr, terminal (RightParen, ")"), terminal (LeftBracket, "{"), b.transformListStat, terminal (RightBracket, "}") )
                           end;


  local attribute transformStat_0 :: Stat = error ("This transformation is not total for non terminal Stat");



}
aspect production p_RepeatUntil
this::Stat ::= REPEAT LeftBracket a::ListStat RightBracket UNTIL b::Expr
{
  this.transformStat = transformStat_1;
  local attribute transformStat_1 :: Stat = case a, b of
                              | _, _ -> p_RepeatUntil( terminal (REPEAT, "REPEAT"), terminal (LeftBracket, "{"), a.transformListStat, terminal (RightBracket, "}"), terminal (UNTIL, "UNTIL"), b.transformExpr )
                           end;


  local attribute transformStat_0 :: Stat = error ("This transformation is not total for non terminal Stat");



}

