grammar Gram;

synthesized attribute transformE :: E;
synthesized attribute transformT :: T;
synthesized attribute transformF :: F;


attribute transformE occurs on A;
attribute transformT occurs on A;
attribute transformF occurs on A;



aspect production p_ADDa
this::A ::= a::A b::A
{
  this.transformE = transformE_1;
  local attribute transformE_1 :: E = case a, b of
                              | _, _ -> p_Add( a.transformE, terminal (Plus, "+"), b.transformT )
                           end;


  local attribute transformE_0 :: E = error ("This transformation is not total for non terminal E");


  this.transformT = transformT_1;
  local attribute transformT_1 :: T = case a, b of
                              | _, _ -> p_Tf( p_Nest( terminal (LeftParen, "("), p_Add( a.transformE, terminal (Plus, "+"), b.transformT ), terminal (RightParen, ")") ) )
                           end;


  local attribute transformT_0 :: T = error ("This transformation is not total for non terminal T");


  this.transformF = transformF_1;
  local attribute transformF_1 :: F = case a, b of
                              | _, _ -> p_Nest( terminal (LeftParen, "("), p_Add( a.transformE, terminal (Plus, "+"), b.transformT ), terminal (RightParen, ")") )
                           end;


  local attribute transformF_0 :: F = error ("This transformation is not total for non terminal F");



}
aspect production p_SUBa
this::A ::= a::A b::A
{
  this.transformE = transformE_2;
  local attribute transformE_2 :: E = case a, b of
                              | p_VALUEa( i ), _ -> if (i.lexeme == "0") then p_Et( p_Tf( p_Neg( terminal (Minus, "-"), a.transformF ) ) ) else transformE_1
                              | _, _ -> transformE_1
                           end;

  local attribute transformE_1 :: E = case a, b of
                              | _, _ -> p_Sub( a.transformE, terminal (Minus, "-"), b.transformT )
                           end;


  local attribute transformE_0 :: E = error ("This transformation is not total for non terminal E");


  this.transformT = transformT_2;
  local attribute transformT_2 :: T = case a, b of
                              | p_VALUEa( i ), _ -> if (i.lexeme == "0") then p_Tf( p_Neg( terminal (Minus, "-"), a.transformF ) ) else transformT_1
                              | _, _ -> transformT_1
                           end;

  local attribute transformT_1 :: T = case a, b of
                              | _, _ -> p_Tf( p_Nest( terminal (LeftParen, "("), p_Sub( a.transformE, terminal (Minus, "-"), b.transformT ), terminal (RightParen, ")") ) )
                           end;


  local attribute transformT_0 :: T = error ("This transformation is not total for non terminal T");


  this.transformF = transformF_2;
  local attribute transformF_2 :: F = case a, b of
                              | p_VALUEa( i ), _ -> if (i.lexeme == "0") then p_Neg( terminal (Minus, "-"), a.transformF ) else transformF_1
                              | _, _ -> transformF_1
                           end;

  local attribute transformF_1 :: F = case a, b of
                              | _, _ -> p_Nest( terminal (LeftParen, "("), p_Sub( a.transformE, terminal (Minus, "-"), b.transformT ), terminal (RightParen, ")") )
                           end;


  local attribute transformF_0 :: F = error ("This transformation is not total for non terminal F");



}
aspect production p_MULa
this::A ::= a::A b::A
{
  this.transformE = transformE_1;
  local attribute transformE_1 :: E = case a, b of
                              | _, _ -> p_Et( p_Mul( a.transformT, terminal (Ex, "*"), b.transformF ) )
                           end;


  local attribute transformE_0 :: E = error ("This transformation is not total for non terminal E");


  this.transformT = transformT_1;
  local attribute transformT_1 :: T = case a, b of
                              | _, _ -> p_Mul( a.transformT, terminal (Ex, "*"), b.transformF )
                           end;


  local attribute transformT_0 :: T = error ("This transformation is not total for non terminal T");


  this.transformF = transformF_1;
  local attribute transformF_1 :: F = case a, b of
                              | _, _ -> p_Nest( terminal (LeftParen, "("), p_Et( p_Mul( a.transformT, terminal (Ex, "*"), b.transformF ) ), terminal (RightParen, ")") )
                           end;


  local attribute transformF_0 :: F = error ("This transformation is not total for non terminal F");



}
aspect production p_VALUEa
this::A ::= a::Int_Lit
{
  this.transformE = transformE_1;
  local attribute transformE_1 :: E = p_Et( p_Tf( p_Value( a ) ) );

  local attribute transformE_0 :: E = error ("This transformation is not total for non terminal E");


  this.transformT = transformT_1;
  local attribute transformT_1 :: T = p_Tf( p_Value( a ) );

  local attribute transformT_0 :: T = error ("This transformation is not total for non terminal T");


  this.transformF = transformF_1;
  local attribute transformF_1 :: F = p_Value( a );

  local attribute transformF_0 :: F = error ("This transformation is not total for non terminal F");



}

