module Source2Silver where

-- WARNING
-- The modules View2Silver and Source2Silver share some core (namely attributeShow and attributePP),
-- I find it more tangling to create yet another another module just with these two than to duplicate them.
-- I could also get everything together in a Transf2Silver module. I am not sure which one is the best
-- solution, but I am aware code duplication is a bad practice and anyone is WARNED that code maintenance
-- MUST ALSO BE DUPLICATED. 

import Types
import Data.List

class Source2Silver a where  
  source2Silver  :: a -> String

instance (Show term, Show nonTerm, Show prod_name, RegExp term) => Source2Silver (CFG term nonTerm prod_name) where
  source2Silver gram@(CFG nTerms prims terms prodName prods) =
      let header = "grammar Gram;\n" -- by default all grammars are called Gram
          -- Print the declaration of NonTerminals
          s1     = unlines $ map auxNT (cfgNonTerms gram)
          -- Print the declaration of Terminals
          s2     = unlines . (map (\x -> "terminal "   ++show x++" '"++regExp x ++"';")) $ terms
          -- Print all the grammar productions
          s3     = unlines . map source2Silver $ prods
      in  unlines [header,s1,s2,s3]
      where
          auxNT nt = "nonterminal "++show nt++" with pp, show;"

-- -- Attribute initialization    
instance (Show prod_name, Show nonTerm, Show term, RegExp term) => Source2Silver (Prod prod_name nonTerm term) where
  source2Silver prod@(Prod prod_name lhsNonTerm rhs) =
      let s1        = "concrete production p_" ++ show prod_name
          s2        = "this::" ++ show lhsNonTerm ++ " ::= " ++ (intercalate " " $ map auxRHS (zip ['a'..'z'] rhs))
          attr_show = attributeShow prod
          attr_pp   = attributePP   prod		  
      in  unlines [s1,s2,"{",attr_show++";",attr_pp++";","}"]
      where
          auxRHS (c, NonTerm x) = [c]++"::"++show x
          auxRHS (c, Term    x) = [c]++"::"++show x
          auxRHS (c, Prim    x) = [c]++"::"++show x

-- -- Attribute Show
attributeShow :: (RegExp term, Show prod_name) => (Prod prod_name nonTerm term) -> String
attributeShow prod@(Prod prod_name lhsNonTerm rhs) =
      let s1 = intercalate " ++ \",\" ++ " $ map aux (zip ['a'..'z'] rhs)
      in  "  this.show = \""++show prod_name++"(\" ++ "++ (if length s1 > 0 then s1 else "\" \"") ++" ++ \")\""
      where
          aux (c, NonTerm x) = [c]++".show"
          aux (c, Term    x) = "\" "++regExp x++" \""
          aux (c, Prim    x) = [c]++".lexeme"

-- -- Attribute PP
attributePP :: (RegExp term, Show prod_name) => (Prod prod_name nonTerm term) -> String
attributePP prod@(Prod prod_name lhsNonTerm rhs) =
      let s1 = intercalate " ++ \" \" ++ " $ map aux (zip ['a'..'z'] rhs)
      in  "  this.pp = " ++ (if length s1 > 0 then s1 else "\"\"")
      where
          aux (c, NonTerm x) = [c]++".pp"
          aux (c, Term    x) = "\"" ++ regExp x ++ "\""
          aux (c, Prim    x) = [c]++".lexeme"
		  
