{-# LANGUAGE FlexibleInstances #-}

module View2Silver where

-- WARNING
-- The modules View2Silver and Source2Silver share some core (namely attributeShow and attributePP),
-- I find it more tangling to create yet another another module just with these two than to duplicate them.
-- I could also get everything together in a Transf2Silver module. I am not sure which one is the best
-- solution, but I am aware code duplication is a bad practice and anyone is WARNED that code maintenance
-- MUST ALSO BE DUPLICATED. 

import Types
import Data.List

class View2Silver a where
  view2Silver    :: a -> String

instance (Show termV, Show nonTermV, Show prod_nameV, RegExp termV, Show nonTermS) =>
  View2Silver (CFG termV nonTermV prod_nameV, CFG termS nonTermS prod_nameS) where
  view2Silver (gram1@(CFG nTermsV primsV termsV prodNameV prodsV),gram2@(CFG nTermsS primsS termsS prodNameS prodsS)) =
      let header = "grammar Gram;\n" -- by default all grammars are called Gram
          -- Print the declaration of NonTerminals
          s1     = unlines $ map auxNT (cfgNonTerms gram1)
          -- Print the declaration of Terminals
          s2     = unlines . (map (\x -> "terminal "   ++show x++" '"++regExp x ++"';")) $ termsV
          -- Generating the prods for the links back
          s3     = generate_links_back gram2
          -- Print all the grammar productions
          s4     = unlines . map view2Silver $ prodsV
      in  concat [header,s1,"\n",s2,s3,"\n\n",s4]
      where
          auxNT nt = "nonterminal "++show nt++" with show, link;"

-- -- Attribute initialization    
instance (Show prod_name, Show nonTerm, Show term, RegExp term) => View2Silver (Prod prod_name nonTerm term) where
  view2Silver prod@(Prod prod_name lhsNonTerm rhs) =
      let s1        = "abstract production p_" ++ show prod_name
          s2        = "this::" ++ show lhsNonTerm ++ " ::= " ++ (intercalate " " $ map auxRHS (zip ['a'..'z'] rhs))
          attr_show = attributeShow prod
      in  unlines [s1,s2,"{",attr_show++";","}"]
      where
          auxRHS (c, NonTerm x) = [c]++"::"++show x
          auxRHS (c, Term    x) = [c]++"::"++show x
          auxRHS (c, Prim    x) = [c]++"::"++show x

-- -- Attribute Show
attributeShow :: (RegExp term, Show prod_name) => (Prod prod_name nonTerm term) -> String
attributeShow prod@(Prod prod_name lhsNonTerm rhs) =
      let s1 = intercalate " ++ \",\" ++ " $ map aux (zip ['a'..'z'] rhs)
      in  "  this.show = \""++show prod_name++"(\" ++ "++ (if length s1 > 0 then s1 else "\" \"") ++" ++ \")\""
      where
          aux (c, NonTerm x) = [c]++".show"
          aux (c, Term    x) = "\" "++regExp x++" \""
          aux (c, Prim    x) = [c]++".lexeme"

-- The 'S' stands for Source, since this is the source grammar. Am I smart or what?
generate_links_back :: (Show nonTermS) => (CFG termS nonTermS prod_nameS) -> String
generate_links_back gramS = let s1 = "-- Links Back\nannotation link :: Link;\nnonterminal Link;"
                                s2 = unlines $ map aux (cfgNonTerms gramS)
                                s3 = "abstract production none\nthis::Link ::=\n{}"
                            in  concat [s1,"\n\n",s2,s3,"\n------"]
                            where aux nt = let s1 = "abstract production link"++show nt
                                               s2 = "this::Link ::= e::"++show nt
                                               s3 = "{}"
                                           in  unlines [s1,s2,s3]






















		  
